#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// Enter the description of your new custom indicator here
    /// </summary>
    [Description("Enter the description of your new custom indicator here")]
    public class rcabri4EMAbyTMFT : Indicator
    {
        #region Variables
        // Wizard generated variables
            private int eMA1length = 8; // Default setting for EMA1length
            private int eMA2length = 13; // Default setting for EMA2length
            private int eMA3length = 21; // Default setting for EMA3length
            private int eMA4length = 34; // Default setting for EMA4length
        // User defined variables (add any user defined variables below)
        #endregion

        /// <summary>
        /// This method is used to configure the indicator and is called once before any bar data is loaded.
        /// </summary>
        protected override void Initialize()
        {
            Add(new Plot(Color.FromKnownColor(KnownColor.Green), PlotStyle.Line, "EMA1"));
            Add(new Plot(Color.FromKnownColor(KnownColor.Blue), PlotStyle.Line, "EMA2"));
            Add(new Plot(Color.FromKnownColor(KnownColor.Fuchsia), PlotStyle.Line, "EMA3"));
            Add(new Plot(Color.FromKnownColor(KnownColor.Red), PlotStyle.Line, "EMA4"));
            Overlay				= true;
			PriceTypeSupported 	= true;
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
            // Use this method for calculating your indicator values. Assign a value to each
            // plot below by replacing 'Close[0]' with your own formula.
            EMA1.Set(EMA(Input,EMA1length)[0]);
            EMA2.Set(EMA(Input,EMA2length)[0]);
            EMA3.Set(EMA(Input,EMA3length)[0]);
            EMA4.Set(EMA(Input,EMA4length)[0]);
        }

        #region Properties
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries EMA1
        {
            get { return Values[0]; }
        }

        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries EMA2
        {
            get { return Values[1]; }
        }

        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries EMA3
        {
            get { return Values[2]; }
        }

        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries EMA4
        {
            get { return Values[3]; }
        }

        [Description("")]
        [GridCategory("Parameters")]
        public int EMA1length
        {
            get { return eMA1length; }
            set { eMA1length = Math.Max(1, value); }
        }

        [Description("")]
        [GridCategory("Parameters")]
        public int EMA2length
        {
            get { return eMA2length; }
            set { eMA2length = Math.Max(1, value); }
        }

        [Description("")]
        [GridCategory("Parameters")]
        public int EMA3length
        {
            get { return eMA3length; }
            set { eMA3length = Math.Max(1, value); }
        }

        [Description("")]
        [GridCategory("Parameters")]
        public int EMA4length
        {
            get { return eMA4length; }
            set { eMA4length = Math.Max(1, value); }
        }
        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private rcabri4EMAbyTMFT[] cachercabri4EMAbyTMFT = null;

        private static rcabri4EMAbyTMFT checkrcabri4EMAbyTMFT = new rcabri4EMAbyTMFT();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public rcabri4EMAbyTMFT rcabri4EMAbyTMFT(int eMA1length, int eMA2length, int eMA3length, int eMA4length)
        {
            return rcabri4EMAbyTMFT(Input, eMA1length, eMA2length, eMA3length, eMA4length);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public rcabri4EMAbyTMFT rcabri4EMAbyTMFT(Data.IDataSeries input, int eMA1length, int eMA2length, int eMA3length, int eMA4length)
        {
            if (cachercabri4EMAbyTMFT != null)
                for (int idx = 0; idx < cachercabri4EMAbyTMFT.Length; idx++)
                    if (cachercabri4EMAbyTMFT[idx].EMA1length == eMA1length && cachercabri4EMAbyTMFT[idx].EMA2length == eMA2length && cachercabri4EMAbyTMFT[idx].EMA3length == eMA3length && cachercabri4EMAbyTMFT[idx].EMA4length == eMA4length && cachercabri4EMAbyTMFT[idx].EqualsInput(input))
                        return cachercabri4EMAbyTMFT[idx];

            lock (checkrcabri4EMAbyTMFT)
            {
                checkrcabri4EMAbyTMFT.EMA1length = eMA1length;
                eMA1length = checkrcabri4EMAbyTMFT.EMA1length;
                checkrcabri4EMAbyTMFT.EMA2length = eMA2length;
                eMA2length = checkrcabri4EMAbyTMFT.EMA2length;
                checkrcabri4EMAbyTMFT.EMA3length = eMA3length;
                eMA3length = checkrcabri4EMAbyTMFT.EMA3length;
                checkrcabri4EMAbyTMFT.EMA4length = eMA4length;
                eMA4length = checkrcabri4EMAbyTMFT.EMA4length;

                if (cachercabri4EMAbyTMFT != null)
                    for (int idx = 0; idx < cachercabri4EMAbyTMFT.Length; idx++)
                        if (cachercabri4EMAbyTMFT[idx].EMA1length == eMA1length && cachercabri4EMAbyTMFT[idx].EMA2length == eMA2length && cachercabri4EMAbyTMFT[idx].EMA3length == eMA3length && cachercabri4EMAbyTMFT[idx].EMA4length == eMA4length && cachercabri4EMAbyTMFT[idx].EqualsInput(input))
                            return cachercabri4EMAbyTMFT[idx];

                rcabri4EMAbyTMFT indicator = new rcabri4EMAbyTMFT();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.EMA1length = eMA1length;
                indicator.EMA2length = eMA2length;
                indicator.EMA3length = eMA3length;
                indicator.EMA4length = eMA4length;
                Indicators.Add(indicator);
                indicator.SetUp();

                rcabri4EMAbyTMFT[] tmp = new rcabri4EMAbyTMFT[cachercabri4EMAbyTMFT == null ? 1 : cachercabri4EMAbyTMFT.Length + 1];
                if (cachercabri4EMAbyTMFT != null)
                    cachercabri4EMAbyTMFT.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachercabri4EMAbyTMFT = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.rcabri4EMAbyTMFT rcabri4EMAbyTMFT(int eMA1length, int eMA2length, int eMA3length, int eMA4length)
        {
            return _indicator.rcabri4EMAbyTMFT(Input, eMA1length, eMA2length, eMA3length, eMA4length);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.rcabri4EMAbyTMFT rcabri4EMAbyTMFT(Data.IDataSeries input, int eMA1length, int eMA2length, int eMA3length, int eMA4length)
        {
            return _indicator.rcabri4EMAbyTMFT(input, eMA1length, eMA2length, eMA3length, eMA4length);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.rcabri4EMAbyTMFT rcabri4EMAbyTMFT(int eMA1length, int eMA2length, int eMA3length, int eMA4length)
        {
            return _indicator.rcabri4EMAbyTMFT(Input, eMA1length, eMA2length, eMA3length, eMA4length);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.rcabri4EMAbyTMFT rcabri4EMAbyTMFT(Data.IDataSeries input, int eMA1length, int eMA2length, int eMA3length, int eMA4length)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.rcabri4EMAbyTMFT(input, eMA1length, eMA2length, eMA3length, eMA4length);
        }
    }
}
#endregion
